TRUE = -1
FALSE = 0

LOCAL_ENVIRON = FALSE	;if false - will use systems (via sets)
			;if true - uses local environment below @ code:110h
FULL_FILESPEC = FALSE

base	segment at 0	;]
	org	16h*4	;]
kbd_offset	dw ?	;]--- make int. vector accessable
kbd_segment	dw ?	;]
base	ends		;]


code	segment
	assume cs:code,ds:code
	org 100h
;*********************************
; PUT NOTHING BETWEEN HERE AND   *
; THE END OF ENVIRONMENT SECTION *
;*********************************
start:	
	jmp begin		;skip past data sections

	org 110h		;forse environment to paragraph address

;******************************************************
;begin local environment section - modify to taste... *
;******************************************************
						     ;*
						     ;*
;local environment for hack.exe			     ;*
						     ;*
environ db "HACK=Simcha",0			     ;*
	db "HACKDIR=C:\game\hack\",0		     ;*
	db "HACKLEVELS=C:\game\hack\",0		     ;*
	db "HACKSAVE=C:\game\hack\hack.sav;n",0	     ;*
	db 0,0,0,0  ;flag end of environment for dos ;*
						     ;*
;******************************************************
;end of local environment section - modify to taste...*
;******************************************************


;************************************************************
IF FULL_FILESPEC					   ;*
							   ;*
pgm_name db "C:\GAME\HACK\HACK.EXE",0	;pgm name to exec  ;*
							   ;*
ELSE							   ;*
							   ;*
pgm_name db "HACK.EXE",0	;pgm name to exec 	   ;*
							   ;*
ENDIF							   ;*
							   ;*
;you can put full path eg <<"C:\GAME\HACK\HACK.EXE",0>>	   ;*
;if you want to load from a fixed directory		   ;*
							   ;*
;w/o full spec, hack.exe must be in the current dir	   ;*
;************************************************************

	even
;param block for exec call
params	dw 0				
	dw 80h
fix1	dw ?
	dw 5ch
fix2	dw ?
	dw 6ch
fix3	dw ?

hello		db	13,10,10
db "PreHack Version 1.1   (C)1985 Simcha Lerner",13,10,10
db "Loads HACK.EXE from current directory while fixing the cursor keys.",13,10,10
db "  unshifted cursor pad = move",13,10
db "  shifted cursor pad   = move until blocked",13,10
db "  alt cursor pad       = move until something interesting"
		db	13,10,10,"fell free to pass me around...",13,10,"$"
exit_msg	db	13,10,10,"Trouble exiting PREHACK...",7,13,10,10,"$"
mem_msg		db	13,10,10,"Trouble freeing memory...",7,13,10,10,"$"
exec_msg	db	13,10,10,"Trouble EXECing HACK.EXE..."
		db	13,10,   "is it in the current directory?",7,13,10,10,"$"


	even

true_int	dd ?		;save original int 16h vector here

save_sp		dw ?		;save sp here (for exec restore)
stk	db  200 DUP ("STACK   ")		;local stack
endstk	dw 00

dummy_int proc far		;filter rtn for int 16h for cursor key mapping

	pushf
	cmp ah,2		;is ah=0 or 1 (ax rtn char code?)
	jb is0			;jump is true
	call cs:true_int	;otherwise, do real int 16h
	ret 2			;and return


is0:
	call cs:true_int	;do real int 16h
	pushf			;save flags, which are relavant if ah was=1

;map cursor pad to cmds for hack

;======================================================================
;map unshifted pad to lower case letters - move 1 space

	cmp ax,4700h		;home
	jne is0_1
	mov ax,1579h		;y
	jmp end0
is0_1:
	cmp ax,4800h		;up arrow
	jne is0_2
	mov ax,256bh		;k
	jmp end0
is0_2:
	cmp ax,4900h		;pgup
	jne is0_3
	mov ax,1675h		;u
	jmp end0
is0_3:
	cmp ax,4b00h		;left arrow
	jne is0_4
	mov ax,2368h		;h
	jmp end0
is0_4:
	cmp ax,4d00h		;right arrow
	jne is0_5
	mov ax,266ch		;l
	jmp end0
is0_5:
	cmp ax,4f00h		;end
	jne is0_6
	mov ax,3062h		;b
	jmp end0
is0_6:
	cmp ax,5000h		;down arrow
	jne is0_7
	mov ax,246ah		;j
	jmp end0
is0_7:
	cmp ax,5100h		;pgdn
	jne is1_0
	mov ax,316eh		;n
	jmp end0
;======================================================================
;map shifted keys to cap letters - move until blocked
is1_0:	cmp ax,4737h		;shift-home
	jne is1_1
	mov ax,1559h		;Y
	jmp end0
is1_1:
	cmp ax,4838h		;shift-up arrow
	jne is1_2
	mov ax,254bh		;K
	jmp end0
is1_2:
	cmp ax,4939h		;shift-pgup
	jne is1_3
	mov ax,1655h		;U
	jmp end0
is1_3:
	cmp ax,4b34h		;shift-left arrow
	jne is1_4
	mov ax,2348h		;H
	jmp end0
is1_4:
	cmp ax,4d36h		;shift-right arrow
	jne is1_5
	mov ax,264ch		;L
	jmp end0
is1_5:
	cmp ax,4f31h		;shift-end
	jne is1_6
	mov ax,3042h		;B
	jmp end0
is1_6:
	cmp ax,5032h		;shift-down arrow
	jne is1_7
	mov ax,244ah		;J
	jmp end0
is1_7:
	cmp ax,5133h		;shift-pgdn
	jne is2_0
	mov ax,314eh		;N
	jmp end0
;======================================================================
;map alt keys to ctrl letters - move fast - until something interesting
is2_0:	cmp ax,0007h		;alt-home
	jne is2_1
	mov ax,1519h		;ctrl-Y
	jmp end0
is2_1:
	cmp ax,0008h		;alt-up arrow
	jne is2_2
	mov ax,250bh		;ctrl-K
	jmp end0
is2_2:
	cmp ax,0009h		;alt-pgup
	jne is2_3
	mov ax,1615h		;ctrl-U
	jmp end0
is2_3:
	cmp ax,0004h		;alt-left arrow
	jne is2_4
	mov ax,2308h		;ctrl-H
	jmp end0
is2_4:
	cmp ax,0006h		;alt-right arrow
	jne is2_5
	mov ax,260ch		;ctrl-L
	jmp end0
is2_5:
	cmp ax,0001h		;alt-end
	jne is2_6
	mov ax,3002h		;ctrl-B
	jmp end0
is2_6:
	cmp ax,0002h		;alt-down arrow
	jne is2_7
	mov ax,240ah		;ctrl-J
	jmp end0
is2_7:
	cmp ax,0003h		;alt-pgdn
	jne end0
	mov ax,310eh		;ctrl-N
	jmp end0
;======================================================================




end0:
	popf		;restore flags as they were when finished real int 16h
	ret 2		;IRET but w/o poping flags from stack 
dummy_int endp


begin	proc near


	mov ax,cs		;set up local stack
	mov ss,ax			  ;"
	mov sp,offset endstk		  ;"
	mov dx,offset hello	;point to hello message
	mov ah,9		;Dos string pring
	int 21h			;do it


;get current int 16h vector and save it (cheating by not using DOS)
	push ds
	mov ax,base
	mov ds,ax

assume ds:base

	mov ax,kbd_offset
	mov word ptr cs:true_int,ax
	mov ax,kbd_segment
	mov word ptr cs:true_int+2,ax

;put vector to our int 16h filter in its place (cheat some more!!)

	mov ax,offset dummy_int
	mov bx,cs
	cli    			;so no int with 1/2 a vector change
	mov kbd_offset,ax
	mov kbd_segment,bx
	sti
	pop ds

assume ds:code

;free up memory for exec	
	mov bx, OFFSET finish
	test bx,0fh
	jz is_aligned
	add bx,10h
is_aligned:
	shr bx,1
	shr bx,1
	shr bx,1
	shr bx,1
	mov ax,4a00h
	int 21h			;set memory block size...
	jc mem_error		;die w/ msg if error (to lazy to check/recover)

;set up for exec and do it...
	mov dx,offset pgm_name
	mov bx,offset params

IF LOCAL_ENVIRON
;generate segment for localized environment string - e.g. no room in system's
	mov ax,cs
	add ax,11h
	mov params,ax		;set up seg for environment
ENDIF

;do segment fixup in param. table
	mov ax,cs		
	mov fix1,ax
	mov fix2,ax
	mov fix3,ax
	
	mov save_sp,sp		;save sp for restoration after exec

	mov ax,4b00h	;exec
	int 21h			;do it!
	jc exec_error		;if error, die w/ msg (if you can!!)

;clean up mess from exec
	mov ax,cs
	mov ds,ax
	mov es,ax
	mov ss,ax
	mov sp,cs:save_sp

;remove filter and restore original vector for int 16h
	mov ax,word ptr cs:true_int
	mov bx,word ptr cs:true_int+2
	push ds
	mov cx,base
	mov ds,cx

assume ds:base

	cli
	mov kbd_offset,ax
	mov kbd_segment,bx
	sti
	pop ds

assume ds:base

;all done, lets go home (exit prehack)

	mov ax,4c00h	;exit w/ return code = 0
	int 21h

exit_error:	;fallthru if exit failed (don't ask, you don't want to know)
	mov ax,cs
	mov ds,ax
	mov dx,offset exit_msg		;ds:dx points to msg...
	mov ah,9			;print string
	int 21h
	mov ax,4cffh			;retry exit - prob. won't work
	int 21h

mem_error:
	mov ax,cs
	mov ds,ax
	mov dx,offset mem_msg		;ds:dx points to msg
	mov ah,9			;dos print string
	int 21h
	jmp clean_and_exit
	
exec_error:
	mov ax,cs
	mov ds,ax
	mov dx,offset exec_msg		;ds:dx points to msg
	mov ah,9			;dos print string
	int 21h

clean_and_exit:

;remove filter and restore original vector for int 16h
	mov ax,word ptr cs:true_int
	mov bx,word ptr cs:true_int+2
	push ds
	mov cx,base
	mov ds,cx

assume ds:base

	cli
	mov kbd_offset,ax
	mov kbd_segment,bx
	sti
	pop ds

assume ds:base

	mov ax,4cffh			;exit w/ error code = ff
	int 21h


finish  db "END OF PREHACK BY SIMCHA LERNER",0

begin	endp

code	ends

	end start



